<template>
  <div>
    <el-container>
      <el-aside width="340px">
        <div class="JKWTree-tree">
          <h3> 设备运行跟踪</h3>
          <el-tree
              :data="treeData"
              :props="defaultProps"
              @node-click="handleNodeClick"></el-tree>
        </div>
      </el-aside>
      <el-container>
        <!--        <el-header>dd</el-header>-->
        <el-main>

          <!-- 搜索框 -->
<!--          <div class="gva-search-box">-->
<!--            <el-form ref="elSearchFormRef" :inline="true" :model="searchInfo" class="demo-form-inline" :rules="searchRule" @keyup.enter="onSubmit">-->

<!--              &lt;!&ndash; 左侧查询输入框 &ndash;&gt;-->
<!--              <el-form-item>-->
<!--                <el-input v-model="searchInfo.keyword" placeholder="" clearable style="width: 200px;"></el-input>-->
<!--              </el-form-item>-->

<!--              &lt;!&ndash; 查询和重置按钮 &ndash;&gt;-->
<!--              <el-form-item>-->
<!--                <el-button type="primary" icon="search" @click="onSubmit">查询</el-button>-->
<!--&lt;!&ndash;                <el-button icon="refresh" @click="onReset">重置</el-button>&ndash;&gt;-->
<!--                <el-button type="primary" icon="plus" @click="openDialog">新增</el-button>-->
<!--              </el-form-item>-->
<!--            </el-form>-->
<!--          </div>-->

          <div class="gva-table-box">

<!--            <el-table ref="multipleTable"-->
<!--                      style="width: 100%"-->
<!--                      border-->
<!--                      tooltip-effect="dark"-->
<!--                      :data="tableData"-->
<!--                      row-key="ID"-->
<!--                      @selection-change="handleSelectionChange">-->
<!--              <el-table-column type="selection" width="55"/>-->
<!--              <el-table-column align="left" label="生产分类" prop="生产分类" width="120" />-->
<!--              <el-table-column align="left" label="工单编号" prop="工单编号" width="120" />-->
<!--              <el-table-column align="left" label="产品代号" prop="产品代号" width="120" />-->
<!--              <el-table-column align="left" label="产品名称" prop="产品名称" width="200" />-->
<!--              <el-table-column align="left" label="接单日期" prop="接单日期" width="160" />-->
<!--              <el-table-column align="left" label="交货日期" prop="交货日期" width="160" />-->
<!--              <el-table-column align="left" label="订单数量" prop="订单数量" width="120" />-->
<!--              <el-table-column align="left" label="计量单位" prop="计量单位" width="120" />-->
<!--              <el-table-column align="left" label="客户名称" prop="客户名称" width="200" />-->
<!--              <el-table-column align="left" label="客户编号" prop="客户编号" width="120" />-->
<!--              <el-table-column align="left" label="备注" prop="备注" width="120" />-->
<!--              <el-table-column align="left" label="客户料号" prop="客户料号" width="120" />-->
<!--              <el-table-column align="left" label="创建用户" prop="创建用户" width="160" />-->
<!--              <el-table-column align="left" label="创建时间" prop="创建时间" width="160" />-->
<!--              <el-table-column align="left" label="修改时间" prop="修改时间" width="160" />-->
<!--              <el-table-column align="left" label="UNIQID" prop="UNIQID" width="120" />-->
<!--              <el-table-column align="left" label="投料率" prop="投料率" width="120" />-->
<!--              <el-table-column align="left" label="销售订单号" prop="销售订单号" width="120" />-->
<!--              <el-table-column align="left" label="操作" min-width="120" fixed='right'>-->
<!--                <template #default="scope">-->
<!--                  <el-button type="primary" link icon="edit" class="table-button" @click="updateCompanyFunc(scope.row)">变更</el-button>-->
<!--                </template>-->
<!--              </el-table-column>-->
<!--            </el-table>-->
            <!--            <div class="gva-pagination">-->
            <!--              <el-pagination layout="total, sizes, prev, pager, next, jumper" :current-page="page" :page-size="pageSize" :page-sizes="[5,10, 30, 50, 100]" :total="total" @current-change="handleCurrentChange" @size-change="handleSizeChange"/>-->
            <!--            </div>-->
          </div>



        </el-main>
      </el-container>
    </el-container>
  </div>
</template>

<script setup>
// 全量引入格式化工具 请按需保留
import {createCompany, deleteCompany, deleteCompanyByIds, updateCompany, findCompany, getCompanyList} from '@/api/company'
import { getDictFunc, formatDate, formatBoolean, filterDict, ReturnArrImg, onDownloadFile } from '@/utils/format'
import { ElMessage, ElMessageBox } from 'element-plus'
import { ref, reactive } from 'vue'
import {DataList, getDepartment, getProduct, getTab, Project, workbench} from "@/api/yunyin/yunying";
defineOptions({name: 'Company'})

// =========== 左侧树侧形结构 ===========

const treeData = ref([]);
const workbenchdata = async () => {
  const data  = await getTab() //接口调用函数
  console.log(data);
};
workbenchdata();

//点击左侧树形获取列表
const tableData = ref([])
const handleNodeClick = async (node) => {
  const custom_code = node.label; // 假设你想使用节点的 label 作为 custom_code
  console.log(custom_code);

};


// 自动化生成的字典（可能为空）以及字段
const formData = ref({
  address: '',
  image: '',
  name: '',
})

// 验证规则
const rule = reactive({
})

const searchRule = reactive({
  createdAt: [
    { validator: (rule, value, callback) => {
        if (searchInfo.value.startCreatedAt && !searchInfo.value.endCreatedAt) {
          callback(new Error('请填写结束日期'))
        } else if (!searchInfo.value.startCreatedAt && searchInfo.value.endCreatedAt) {
          callback(new Error('请填写开始日期'))
        } else if (searchInfo.value.startCreatedAt && searchInfo.value.endCreatedAt && (searchInfo.value.startCreatedAt.getTime() === searchInfo.value.endCreatedAt.getTime() || searchInfo.value.startCreatedAt.getTime() > searchInfo.value.endCreatedAt.getTime())) {
          callback(new Error('开始日期应当早于结束日期'))
        } else {
          callback()
        }
      }, trigger: 'change' }
  ],
})

const elFormRef = ref()
const elSearchFormRef = ref()

// =========== 表格控制部分 ===========
const page = ref(1)
const total = ref(0)
const pageSize = ref(10)
const searchInfo = ref({})

// 重置
const onReset = () => {
  searchInfo.value = {}
  getTableData()
}

// 搜索
const onSubmit = () => {
  elSearchFormRef.value?.validate(async(valid) => {
    if (!valid) return
    page.value = 1
    pageSize.value = 10
    getTableData()
  })
}

// 分页
const handleSizeChange = (val) => {
  pageSize.value = val
  getTableData()
}

// 修改页面容量
const handleCurrentChange = (val) => {
  page.value = val
  getTableData()
}

// 查询
const getTableData = async() => {
  const table = await getCompanyList({ page: page.value, pageSize: pageSize.value, ...searchInfo.value })
  if (table.code === 0) {
    tableData.value = table.data.list
    total.value = table.data.total
    page.value = table.data.page
    pageSize.value = table.data.pageSize
  }
}

getTableData()

// ============== 表格控制部分结束 ===============

// 获取需要的字典 可能为空 按需保留
const setOptions = async () =>{
}

// 获取需要的字典 可能为空 按需保留
setOptions()


// 多选数据
const multipleSelection = ref([])
// 多选
const handleSelectionChange = (val) => {
  multipleSelection.value = val
}

// 删除行
const deleteRow = (row) => {
  ElMessageBox.confirm('确定要删除吗?', '提示', {
    confirmButtonText: '确定',
    cancelButtonText: '取消',
    type: 'warning'
  }).then(() => {
    deleteCompanyFunc(row)
  })
}


// 批量删除控制标记
const deleteVisible = ref(false)

// 多选删除
const onDelete = async() => {
  const ids = []
  if (multipleSelection.value.length === 0) {
    ElMessage({
      type: 'warning',
      message: '请选择要删除的数据'
    })
    return
  }
  multipleSelection.value &&
  multipleSelection.value.map(item => {
    ids.push(item.ID)
  })
  const res = await deleteCompanyByIds({ ids })
  if (res.code === 0) {
    ElMessage({
      type: 'success',
      message: '删除成功'
    })
    if (tableData.value.length === ids.length && page.value > 1) {
      page.value--
    }
    deleteVisible.value = false
    getTableData()
  }
}

// 行为控制标记（弹窗内部需要增还是改）
const type = ref('')

// 更新行
const updateCompanyFunc = async(row) => {
  // const res = await findCompany({ ID: row.ID })
  // type.value = 'update'
  // if (res.code === 0) {
  //     formData.value = res.data.recompany
  //     dialogFormVisible.value = true
  // }
  dialogFormVisible.value = true
}


// 删除行
const deleteCompanyFunc = async (row) => {
  const res = await deleteCompany({ ID: row.ID })
  if (res.code === 0) {
    ElMessage({
      type: 'success',
      message: '删除成功'
    })
    if (tableData.value.length === 1 && page.value > 1) {
      page.value--
    }
    getTableData()
  }
}

// 弹窗控制标记
const dialogFormVisible = ref(false)


// 查看详情控制标记
const detailShow = ref(false)


// 打开详情弹窗
const openDetailShow = () => {
  detailShow.value = true
}


// 打开详情
const getDetails = async (row) => {
  // 打开弹窗
  const res = await findCompany({ ID: row.ID })
  if (res.code === 0) {
    formData.value = res.data.recompany
    openDetailShow()
  }
}


// 关闭详情弹窗
const closeDetailShow = () => {
  detailShow.value = false
  formData.value = {
    address: '',
    image: '',
    name: '',
  }
}


// 打开弹窗
const openDialog = () => {
  type.value = 'create'
  dialogFormVisible.value = true
}

// 关闭弹窗
const closeDialog = () => {
  dialogFormVisible.value = false
  formData.value = {
    address: '',
    image: '',
    name: '',
  }
}
// 弹窗确定
const enterDialog = async () => {
  elFormRef.value?.validate( async (valid) => {
    if (!valid) return
    let res
    switch (type.value) {
      case 'create':
        res = await createCompany(formData.value)
        break
      case 'update':
        res = await updateCompany(formData.value)
        break
      default:
        res = await createCompany(formData.value)
        break
    }
    if (res.code === 0) {
      ElMessage({
        type: 'success',
        message: '创建/更改成功'
      })
      closeDialog()
      getTableData()
    }
  })
}

</script>

<style>
.JKWTree-container {
  display: flex;
}

.JKWTree-tree {
  width: 300px;
  background-color: #fff;
  padding: 10px;
  margin-right: 20px;
}

.JKWTree-tree h3 {
  font-size: 15px;
  font-weight: 700;
  margin: 10px 0;
}

.JKWTree-content {
  flex: 1;
}
</style>
